<?php

namespace Drupal\devel_ladybug\Plugin\Devel\Dumper;

use Drupal\devel\DevelDumperBase;
use Ladybug\Dumper;

/**
 * Provides a Ladybug dumper plugin.
 *
 * @DevelDumper(
 *   id = "ladybug",
 *   label = @Translation("Ladybug"),
 *   description = @Translation("Wrapper for <a href='https://github.com/raulfraile/ladybug'>Ladybug</a> debugging tool."),
 * )
 */
class Ladybug extends DevelDumperBase {

  private $dumper;

  /**
   * {@inheritdoc}
   */
  public function __construct(array $configuration, $plugin_id, $plugin_definition) {
    parent::__construct($configuration, $plugin_id, $plugin_definition);
    if (!$this->dumper) {
      $this->dumper = new Dumper();
      $this->dumper->setTheme('modern');
    }
  }

  /**
   * {@inheritdoc}
   */
  public function dump($input, $name = NULL) {
    echo (string) $this->export($input, $name);
  }

  /**
   * {@inheritdoc}
   */
  public function export($input, $name = NULL) {
    ob_start();
    echo $this->dumper->dump($input, $name);
    return $this->setSafeMarkup(ob_get_clean());
  }

  /**
   * {@inheritdoc}
   */
  public static function checkRequirements() {
    // Requirement validation is already located in install file.
    return TRUE;
  }

}
